# MapperReadKeyValuesRepo

open class MapperReadKeyValuesRepo < FromKey , FromValue , ToKey , ToValue >(to: ReadKeyValuesRepo < ToKey , ToValue >, mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >) : ReadKeyValuesRepo < FromKey , FromValue > , MapperRepo < FromKey , FromValue , ToKey , ToValue > (source)

## Constructors

MapperReadKeyValuesRepo
Link copied to clipboard
constructor(to: ReadKeyValuesRepo < ToKey , ToValue >, mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >)

## Properties

keyMapper
Link copied to clipboard
open override val keyMapper : SimpleSuspendableMapper < FromKey , ToKey >
valueMapper
Link copied to clipboard
open override val valueMapper : SimpleSuspendableMapper < FromValue , ToValue >

## Functions

asReadKeyValueRepo
Link copied to clipboard
fun < K , V > ReadKeyValuesRepo < K , V >. asReadKeyValueRepo (): ReadKeyValueFromKeyValuesRepo < K , V >
cached
Link copied to clipboard
fun < Key , Value > ReadKeyValuesRepo < Key , Value >. cached (kvCache: KVCache < Key , List < Value >>, locker: SmartRWLocker = SmartRWLocker()): ReadKeyValuesCacheRepo < Key , Value >
fun < Key , Value > ReadKeyValuesRepo < Key , Value >. cached (kvCache: KeyValueRepo < Key , List < Value >>, locker: SmartRWLocker = SmartRWLocker()): FullReadKeyValuesCacheRepo < Key , Value >
contains
Link copied to clipboard
open suspend override fun contains (k: FromKey ): Boolean
open suspend override fun contains (k: FromKey , v: FromValue ): Boolean
count
Link copied to clipboard
open suspend override fun count (): Long
open suspend override fun count (k: FromKey ): Long
diff
Link copied to clipboard
suspend fun < Id , Registered > ReadKeyValuesRepo < Id , Registered >. diff (other: Map < Id , List < Registered >>): MapDiff < Id , List < Registered >>
directlyCached
Link copied to clipboard
fun < Key , Value > ReadKeyValuesRepo < Key , Value >. directlyCached (kvCache: KeyValueRepo < Key , List < Value >>, locker: SmartRWLocker = SmartRWLocker()): DirectFullReadKeyValuesCacheRepo < Key , Value >
get
Link copied to clipboard
open suspend override fun get (k: FromKey , pagination: Pagination , reversed: Boolean ): PaginationResult < FromValue >
getAll
Link copied to clipboard
open suspend fun getAll (reverseLists: Boolean = false): Map < FromKey , List < FromValue >>

WARNING!!! THIS METHOD PROBABLY IS NOT EFFICIENT, USE WITH CAUTION

open suspend fun getAll (k: FromKey , reversed: Boolean = false): List < FromValue >
keys
Link copied to clipboard
open suspend override fun keys (pagination: Pagination , reversed: Boolean ): PaginationResult < FromKey >
open suspend override fun keys (v: FromValue , pagination: Pagination , reversed: Boolean ): PaginationResult < FromKey >
maxPagePagination
Link copied to clipboard
inline suspend fun ReadKeyValuesRepo <*, *>. maxPagePagination (): SimplePagination
toInnerKey
Link copied to clipboard
open suspend override fun ToKey . toInnerKey (): FromKey
toInnerValue
Link copied to clipboard
open suspend override fun ToValue . toInnerValue (): FromValue
toOutKey
Link copied to clipboard
open suspend override fun FromKey . toOutKey (): ToKey
toOutValue
Link copied to clipboard
open suspend override fun FromValue . toOutValue (): ToValue
withMapper
Link copied to clipboard
inline fun < FromKey , FromValue , ToKey , ToValue > ReadKeyValuesRepo < ToKey , ToValue >. withMapper (mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >): ReadKeyValuesRepo < FromKey , FromValue >
inline fun < FromKey , FromValue , ToKey , ToValue > ReadKeyValuesRepo < ToKey , ToValue >. withMapper (noinline keyFromToTo: suspend FromKey .() -> ToKey = { this as ToKey }, noinline valueFromToTo: suspend FromValue .() -> ToValue = { this as ToValue }, noinline keyToToFrom: suspend ToKey .() -> FromKey = { this as FromKey }, noinline valueToToFrom: suspend ToValue .() -> FromValue = { this as FromValue }): ReadKeyValuesRepo < FromKey , FromValue >